
#include "MacroPatternMatch.h"

#include "HROOTTreeTBranch.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttMarker.h"

#include "TTree.h"

#include "HROOTTreeTTree.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TTree)
TATTLINE_DEF_VIRT(TTree)
TATTFILL_DEF_VIRT(TTree)
TATTMARKER_DEF_VIRT(TTree)
TOBJECT_DEF_VIRT(TTree)
DELETABLE_DEF_VIRT(TTree)
TTREE_DEF_VIRT(TTree)
TTREE_DEF_NONVIRT(TTree)
TTREE_DEF_ACCESSOR(TTree)

