{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Tree.TBranch.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Tree.TBranch.RawType
import HROOT.Tree.TBranch.FFI
import HROOT.Tree.TBranch.Interface
import HROOT.Tree.TBranch.Cast
import HROOT.Tree.TBranch.RawType
import HROOT.Tree.TBranch.Cast
import HROOT.Tree.TBranch.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITBranch (TBranch) where

instance () => ITNamed (TBranch) where
        setName = xform1 c_tbranch_setname
        setNameTitle = xform2 c_tbranch_setnametitle
        setTitle = xform1 c_tbranch_settitle

instance () => ITAttFill (TBranch) where
        setFillColor = xform1 c_tbranch_setfillcolor
        setFillStyle = xform1 c_tbranch_setfillstyle

instance () => ITObject (TBranch) where
        clear = xform1 c_tbranch_clear
        draw = xform1 c_tbranch_draw
        findObject = xform1 c_tbranch_findobject
        getName = xform0 c_tbranch_getname
        isA = xform0 c_tbranch_isa
        paint = xform1 c_tbranch_paint
        printObj = xform1 c_tbranch_printobj
        saveAs = xform2 c_tbranch_saveas
        write = xform3 c_tbranch_write
        write_ = xform0 c_tbranch_write_

instance () => IDeletable (TBranch) where
        delete = xform0 c_tbranch_delete
