
#include "MacroPatternMatch.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttFill.h"

#include "TBranch.h"

#include "HROOTTreeTBranch.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TBranch)
TATTFILL_DEF_VIRT(TBranch)
TOBJECT_DEF_VIRT(TBranch)
DELETABLE_DEF_VIRT(TBranch)
TBRANCH_DEF_VIRT(TBranch)
TBRANCH_DEF_NONVIRT(TBranch)
TBRANCH_DEF_ACCESSOR(TBranch)

